<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/ADSL/include/ADSL/DirectiveSequencer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_edb1b7e8f1a5d5a1b864206edd6d398d.html">ADSL</a></li><li class="navelem"><a class="el" href="dir_0ad8890ca26b658b7f4a1511f46d3706.html">include</a></li><li class="navelem"><a class="el" href="dir_02d2e4cabccc4f164a834c9d2dadd160.html">ADSL</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">DirectiveSequencer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_directive_sequencer_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_ADSL_INCLUDE_ADSL_DIRECTIVESEQUENCER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_ADSL_INCLUDE_ADSL_DIRECTIVESEQUENCER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;condition_variable&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;deque&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_exception_encountered_sender_interface_8h.html">AVSCommon/SDKInterfaces/ExceptionEncounteredSenderInterface.h</a>&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_directive_sequencer_interface_8h.html">AVSCommon/SDKInterfaces/DirectiveSequencerInterface.h</a>&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_directive_processor_8h.html">ADSL/DirectiveProcessor.h</a>&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_directive_router_8h.html">ADSL/DirectiveRouter.h</a>&quot;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">namespace </span>adsl {</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html">   37</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html">DirectiveSequencer</a> : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_sequencer_interface.html">avsCommon::sdkInterfaces::DirectiveSequencerInterface</a> {</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">static</span> std::unique_ptr&lt;DirectiveSequencerInterface&gt; <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#aad3101939714df4b3e1e54247650a01f">create</a>(</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface&gt; exceptionSender);</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#a99af33f91c32821be7ebce88c28f7ab8">addDirectiveHandler</a>(std::shared_ptr&lt;avsCommon::sdkInterfaces::DirectiveHandlerInterface&gt; handler) <span class="keyword">override</span>;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#abe676bf22ffd022a04659f67bc420962">removeDirectiveHandler</a>(std::shared_ptr&lt;avsCommon::sdkInterfaces::DirectiveHandlerInterface&gt; handler) <span class="keyword">override</span>;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#a9ed32174308b933bdfe19b3697ffd1aa">setDialogRequestId</a>(<span class="keyword">const</span> std::string&amp; dialogRequestId) <span class="keyword">override</span>;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#aee57f71ed70dd58104b019a86b13a3ff">onDirective</a>(std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; directive) <span class="keyword">override</span>;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#a15e75fdc20b5911930bc2056e25c4911">disable</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#abb8b7f4bbf3d0b9b80db1281203897af">enable</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html">DirectiveSequencer</a>(std::shared_ptr&lt;avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface&gt; exceptionSender);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keywordtype">void</span> doShutdown() <span class="keyword">override</span>;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keywordtype">void</span> receivingLoop();</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keywordtype">void</span> receiveDirectiveLocked(std::unique_lock&lt;std::mutex&gt;&amp; lock);</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    std::mutex m_mutex;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface&gt; m_exceptionSender;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordtype">bool</span> m_isShuttingDown;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keywordtype">bool</span> m_isEnabled;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html">DirectiveRouter</a> m_directiveRouter;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    std::shared_ptr&lt;DirectiveProcessor&gt; m_directiveProcessor;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    std::deque&lt;std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt;&gt; m_receivingQueue;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    std::condition_variable m_wakeReceivingLoop;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    std::thread m_receivingThread;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;};</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;}  <span class="comment">// namespace adsl</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_ADSL_INCLUDE_ADSL_DIRECTIVESEQUENCER_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer_html_a99af33f91c32821be7ebce88c28f7ab8"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#a99af33f91c32821be7ebce88c28f7ab8">alexaClientSDK::adsl::DirectiveSequencer::addDirectiveHandler</a></div><div class="ttdeci">bool addDirectiveHandler(std::shared_ptr&lt; avsCommon::sdkInterfaces::DirectiveHandlerInterface &gt; handler) override</div><div class="ttdef"><b>Definition:</b> DirectiveSequencer.cpp:53</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html">alexaClientSDK::adsl::DirectiveSequencer</a></div><div class="ttdef"><b>Definition:</b> DirectiveSequencer.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_sequencer_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_sequencer_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::DirectiveSequencerInterface</a></div><div class="ttdef"><b>Definition:</b> DirectiveSequencerInterface.h:44</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer_html_abb8b7f4bbf3d0b9b80db1281203897af"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#abb8b7f4bbf3d0b9b80db1281203897af">alexaClientSDK::adsl::DirectiveSequencer::enable</a></div><div class="ttdeci">void enable() override</div><div class="ttdef"><b>Definition:</b> DirectiveSequencer.cpp:119</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer_html_abe676bf22ffd022a04659f67bc420962"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#abe676bf22ffd022a04659f67bc420962">alexaClientSDK::adsl::DirectiveSequencer::removeDirectiveHandler</a></div><div class="ttdeci">bool removeDirectiveHandler(std::shared_ptr&lt; avsCommon::sdkInterfaces::DirectiveHandlerInterface &gt; handler) override</div><div class="ttdef"><b>Definition:</b> DirectiveSequencer.cpp:57</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_router_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html">alexaClientSDK::adsl::DirectiveRouter</a></div><div class="ttdef"><b>Definition:</b> DirectiveRouter.h:34</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer_html_aad3101939714df4b3e1e54247650a01f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#aad3101939714df4b3e1e54247650a01f">alexaClientSDK::adsl::DirectiveSequencer::create</a></div><div class="ttdeci">static std::unique_ptr&lt; DirectiveSequencerInterface &gt; create(std::shared_ptr&lt; avsCommon::sdkInterfaces::ExceptionEncounteredSenderInterface &gt; exceptionSender)</div><div class="ttdef"><b>Definition:</b> DirectiveSequencer.cpp:44</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="_directive_router_8h_html"><div class="ttname"><a href="_directive_router_8h.html">DirectiveRouter.h</a></div></div>
<div class="ttc" id="_exception_encountered_sender_interface_8h_html"><div class="ttname"><a href="_exception_encountered_sender_interface_8h.html">ExceptionEncounteredSenderInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer_html_a9ed32174308b933bdfe19b3697ffd1aa"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#a9ed32174308b933bdfe19b3697ffd1aa">alexaClientSDK::adsl::DirectiveSequencer::setDialogRequestId</a></div><div class="ttdeci">void setDialogRequestId(const std::string &amp;dialogRequestId) override</div><div class="ttdef"><b>Definition:</b> DirectiveSequencer.cpp:61</div></div>
<div class="ttc" id="_directive_processor_8h_html"><div class="ttname"><a href="_directive_processor_8h.html">DirectiveProcessor.h</a></div></div>
<div class="ttc" id="_directive_sequencer_interface_8h_html"><div class="ttname"><a href="_directive_sequencer_interface_8h.html">DirectiveSequencerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer_html_aee57f71ed70dd58104b019a86b13a3ff"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#aee57f71ed70dd58104b019a86b13a3ff">alexaClientSDK::adsl::DirectiveSequencer::onDirective</a></div><div class="ttdeci">bool onDirective(std::shared_ptr&lt; avsCommon::avs::AVSDirective &gt; directive) override</div><div class="ttdef"><b>Definition:</b> DirectiveSequencer.cpp:65</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer_html_a15e75fdc20b5911930bc2056e25c4911"><div class="ttname"><a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_sequencer.html#a15e75fdc20b5911930bc2056e25c4911">alexaClientSDK::adsl::DirectiveSequencer::disable</a></div><div class="ttdeci">void disable() override</div><div class="ttdef"><b>Definition:</b> DirectiveSequencer.cpp:110</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
